CallbackProxy (JNA API)
Description: declaration: package: com.sun.jna.platform.win32.COM.util, class: CallbackProxy

Package com.sun.jna.platform.win32.COM.util

# Class CallbackProxy

java.lang.Object
com.sun.jna.platform.win32.COM.util.CallbackProxy

All Implemented Interfaces:
  `IDispatch`, `IDispatchCallback`, `IUnknown`, `IUnknownCallback`

public class CallbackProxy extends Object implements IDispatchCallback

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `(package private) Class<?>`
  `comEventCallbackInterface`
  `(package private) IComEventCallbackListener`
  `comEventCallbackListener`
  `DispatchListener`
  `dispatchListener`
  `(package private) Map<OaIdl.DISPID,Method>`
  `dsipIdMap`
  `(package private) ObjectFactory`
  `factory`
  `(package private) Guid.REFIID`
  `listenedToRiid`

  ### Fields inherited from interface com.sun.jna.platform.win32.COM.IDispatch

  `IID_IDISPATCH`

  ### Fields inherited from interface com.sun.jna.platform.win32.COM.IUnknown

  `IID_IUNKNOWN`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CallbackProxy(ObjectFactory factory, Class<?> comEventCallbackInterface, IComEventCallbackListener comEventCallbackListener)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `AddRef()`
  `WinNT.HRESULT`
  `GetIDsOfNames(Guid.REFIID riid, WString[] rgszNames, int cNames, WinDef.LCID lcid, OaIdl.DISPIDByReference rgDispId)`
  Maps a single member and an optional set of argument names to a corresponding set of integer DISPIDs, which can be used on subsequent calls to Invoke.
  `Pointer`
  `getPointer()`
  `WinNT.HRESULT`
  `GetTypeInfo(WinDef.UINT iTInfo, WinDef.LCID lcid, PointerByReference ppTInfo)`
  Retrieves the type information for an object, which can then be used to get the type information for an interface.
  `WinNT.HRESULT`
  `GetTypeInfoCount(WinDef.UINTByReference pctinfo)`
  Retrieves the number of type information interfaces that an object provides (either 0 or 1).
  `WinNT.HRESULT`
  `Invoke(OaIdl.DISPID dispIdMember, Guid.REFIID riid, WinDef.LCID lcid, WinDef.WORD wFlags, OleAuto.DISPPARAMS.ByReference pDispParams, Variant.VARIANT.ByReference pVarResult, OaIdl.EXCEPINFO.ByReference pExcepInfo, IntByReference puArgErr)`
  Provides access to properties and methods exposed by an object.
  `(package private) void`
  `invokeOnThread(OaIdl.DISPID dispIdMember, Guid.REFIID riid, WinDef.LCID lcid, WinDef.WORD wFlags, OleAuto.DISPPARAMS.ByReference pDispParams)`
  `WinNT.HRESULT`
  `QueryInterface(Guid.REFIID refid, PointerByReference ppvObject)`
  `int`
  `Release()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### factory

    ObjectFactory factory

  - ### comEventCallbackInterface

    Class<?> comEventCallbackInterface

  - ### comEventCallbackListener

    IComEventCallbackListener comEventCallbackListener

  - ### listenedToRiid

    Guid.REFIID listenedToRiid

  - ### dispatchListener

    public DispatchListener dispatchListener

  - ### dsipIdMap

    Map<OaIdl.DISPID,Method> dsipIdMap

- ## Constructor Details

  - ### CallbackProxy

    public CallbackProxy(ObjectFactory factory, Class<?> comEventCallbackInterface, IComEventCallbackListener comEventCallbackListener)

- ## Method Details

  - ### invokeOnThread

    void invokeOnThread(OaIdl.DISPID dispIdMember, Guid.REFIID riid, WinDef.LCID lcid, WinDef.WORD wFlags, OleAuto.DISPPARAMS.ByReference pDispParams)

  - ### getPointer

    public Pointer getPointer()
    Specified by:
      `getPointer` in interface `IUnknownCallback`

  - ### GetTypeInfoCount

    public WinNT.HRESULT GetTypeInfoCount(WinDef.UINTByReference pctinfo)
    Description copied from interface: `IDispatch`
    Retrieves the number of type information interfaces that an object provides (either 0 or 1).
    Specified by:
      `GetTypeInfoCount` in interface `IDispatch`
    Parameters:
      `pctinfo` - The number of type information interfaces provided by the object. If the object provides type information, this number is 1; otherwise the number is 0.
    Returns:
      This method can return one of these values. S_OK Success. E_NOTIMPL Failure.

  - ### GetTypeInfo

    public WinNT.HRESULT GetTypeInfo(WinDef.UINT iTInfo, WinDef.LCID lcid, PointerByReference ppTInfo)
    Description copied from interface: `IDispatch`
    Retrieves the type information for an object, which can then be used to get the type information for an interface.
    Specified by:
      `GetTypeInfo` in interface `IDispatch`
    Parameters:
      `iTInfo` - The type information to return. Pass 0 to retrieve type information for the IDispatch implementation.
      `lcid` - The locale identifier for the type information. An object may be able to return different type information for different languages. This is important for classes that support localized member names. For classes that do not support localized member names, this parameter can be ignored.
      `ppTInfo` - The requested type information object.
    Returns:
      S_OK Success. DISP_E_BADINDEX The iTInfo parameter was not 0.

  - ### GetIDsOfNames

    public WinNT.HRESULT GetIDsOfNames(Guid.REFIID riid, WString[] rgszNames, int cNames, WinDef.LCID lcid, OaIdl.DISPIDByReference rgDispId)
    Description copied from interface: `IDispatch`
    Maps a single member and an optional set of argument names to a corresponding set of integer DISPIDs, which can be used on subsequent calls to Invoke. The dispatch function DispGetIDsOfNames provides a standard implementation of GetIDsOfNames.
    Specified by:
      `GetIDsOfNames` in interface `IDispatch`
    Parameters:
      `riid` - Reserved for future use. Must be IID_NULL.
      `rgszNames` - The array of names to be mapped.
      `cNames` - The count of the names to be mapped.
      `lcid` - The locale context in which to interpret the names.
      `rgDispId` - Caller-allocated array, each element of which contains an identifier (ID) corresponding to one of the names passed in the rgszNames array. The first element represents the member name. The subsequent elements represent each of the member's parameters.
    Returns:
      status of the operation

  - ### Invoke

    public WinNT.HRESULT Invoke(OaIdl.DISPID dispIdMember, Guid.REFIID riid, WinDef.LCID lcid, WinDef.WORD wFlags, OleAuto.DISPPARAMS.ByReference pDispParams, Variant.VARIANT.ByReference pVarResult, OaIdl.EXCEPINFO.ByReference pExcepInfo, IntByReference puArgErr)
    Description copied from interface: `IDispatch`
    Provides access to properties and methods exposed by an object. The dispatch function DispInvoke provides a standard implementation of Invoke.
    Specified by:
      `Invoke` in interface `IDispatch`
    Parameters:
      `dispIdMember` - Identifies the member. Use GetIDsOfNames or the object's documentation to obtain the dispatch identifier.
      `riid` - Reserved for future use. Must be IID_NULL.
      `lcid` - The locale context in which to interpret arguments. The lcid is used by the GetIDsOfNames function, and is also passed to Invoke to allow the object to interpret its arguments specific to a locale.

      Applications that do not support multiple national languages can ignore this parameter. For more information, refer to Supporting Multiple National Languages and Exposing ActiveX Objects.
      `wFlags` - Flags describing the context of the Invoke call. DISPATCH_METHOD The member is invoked as a method. If a property has the same name, both this and the DISPATCH_PROPERTYGET flag can be set. DISPATCH_PROPERTYGET The member is retrieved as a property or data member. DISPATCH_PROPERTYPUT The member is changed as a property or data member. DISPATCH_PROPERTYPUTREF The member is changed by a reference assignment, rather than a value assignment. This flag is valid only when the property accepts a reference to an object.
      `pDispParams` - Pointer to a DISPPARAMS structure containing an array of arguments, an array of argument DISPIDs for named arguments, and counts for the number of elements in the arrays.
      `pVarResult` - Pointer to the location where the result is to be stored, or NULL if the caller expects no result. This argument is ignored if DISPATCH_PROPERTYPUT or DISPATCH_PROPERTYPUTREF is specified.
      `pExcepInfo` - Pointer to a structure that contains exception information. This structure should be filled in if DISP_E_EXCEPTION is returned. Can be NULL.
      `puArgErr` - The index within rgvarg of the first argument that has an error. Arguments are stored in pDispParams->rgvarg in reverse order, so the first argument is the one with the highest index in the array. This parameter is returned only when the resulting return value is DISP_E_TYPEMISMATCH or DISP_E_PARAMNOTFOUND. This argument can be set to null. For details, see Returning Errors.
    Returns:
      This method can return one of these values. S_OK Success. DISP_E_BADPARAMCOUNT The number of elements provided to DISPPARAMS is different from the number of arguments accepted by the method or property. DISP_E_BADVARTYPE One of the arguments in DISPPARAMS is not a valid variant type. DISP_E_EXCEPTION The application needs to raise an exception. In this case, the structure passed in pexcepinfo should be filled in. DISP_E_MEMBERNOTFOUND The requested member does not exist. DISP_E_NONAMEDARGS This implementation of IDispatch does not support named arguments. DISP_E_OVERFLOW One of the arguments in DISPPARAMS could not be coerced to the specified type. DISP_E_PARAMNOTFOUND One of the parameter IDs does not correspond to a parameter on the method. In this case, puArgErr is set to the first argument that contains the error. DISP_E_TYPEMISMATCH One or more of the arguments could not be coerced. The index of the first parameter with the incorrect type within rgvarg is returned in puArgErr. DISP_E_UNKNOWNINTERFACE The interface identifier passed in riid is not IID_NULL. DISP_E_UNKNOWNLCID The member being invoked interprets string arguments according to the LCID, and the LCID is not recognized. If the LCID is not needed to interpret arguments, this error should not be returned DISP_E_PARAMNOTOPTIONAL A required parameter was omitted.

  - ### QueryInterface

    public WinNT.HRESULT QueryInterface(Guid.REFIID refid, PointerByReference ppvObject)
    Specified by:
      `QueryInterface` in interface `IUnknown`

  - ### AddRef

    public int AddRef()
    Specified by:
      `AddRef` in interface `IUnknown`

  - ### Release

    public int Release()
    Specified by:
      `Release` in interface `IUnknown`